package kieker.webgui.common;

/**
 * This is a simple helper class which can store three values.
 * 
 * @author Nils Christian Ehmke
 * @version 1.0
 * 
 * @param <F>
 *            The type of the first element.
 * @param <S>
 *            The type of the second element.
 * @param <T>
 *            The type of the third element.
 */
public class Triple<F, S, T> {
	/**
	 * This is the first element.
	 */
	private F fst;
	/**
	 * This is the second element.
	 */
	private S snd;
	/**
	 * This is the third element
	 */
	private T thd;

	/**
	 * Creates a new instance of this class with null values stored for the elements.
	 */
	public Triple() {
		// No code necessary
	}

	/**
	 * Creates a new instance of this class using the given values.
	 * 
	 * @param fst
	 *            The first element to be stored in this object.
	 * @param snd
	 *            The second element to be stored in this object.
	 * @param thd
	 *            The third element to be stored in this object.
	 */
	public Triple(final F fst, final S snd, final T thd) {
		this.fst = fst;
		this.snd = snd;
		this.thd = thd;
	}

	/**
	 * Delivers the first element.
	 * 
	 * @return The first element.
	 */
	public F getFst() {
		return this.fst;
	}

	/**
	 * Sets the first element to a new value.
	 * 
	 * @param fst
	 *            The new first element.
	 */
	public void setFst(final F fst) {
		this.fst = fst;
	}

	/**
	 * Delivers the second element.
	 * 
	 * @return The second element.
	 */
	public S getSnd() {
		return this.snd;
	}

	/**
	 * Sets the second element to a new value.
	 * 
	 * @param snd
	 *            The new second element.
	 */
	public void setSnd(final S snd) {
		this.snd = snd;
	}

	/**
	 * Delivers the third element.
	 * 
	 * @return The third element.
	 */
	public T getThd() {
		return this.thd;
	}

	/**
	 * Sets the third element to a new value.
	 * 
	 * @param thd
	 *            The new third element.
	 */
	public void setThd(final T thd) {
		this.thd = thd;
	}

}
